// Copyright 2011 Intel Corporation
// All Rights Reserved
//
// Permission is granted to use, copy, distribute and prepare derivative works of this
// software for any purpose and without fee, provided, that the above copyright notice
// and this statement appear in all copies. Intel makes no representations about the
// suitability of this software for any purpose. THIS SOFTWARE IS PROVIDED "AS IS."
// INTEL SPECIFICALLY DISCLAIMS ALL WARRANTIES, EXPRESS OR IMPLIED, AND ALL LIABILITY,
// INCLUDING CONSEQUENTIAL AND OTHER INDIRECT DAMAGES, FOR THE USE OF THIS SOFTWARE,
// INCLUDING LIABILITY FOR INFRINGEMENT OF ANY PROPRIETARY RIGHTS, AND INCLUDING THE
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  Intel does not
// assume any responsability for any errors which may appear in this software nor any
// responsibility to update it.

#pragma once

#include "CPUT.h"
#include "CPUTGeometrySprite.h"
#include "CPUTBufferDX11.h"


class CPUTZoomBox
{
    float2						mvZoomCenterPos;
    float2                      mvZoomSourceSize;
    int                         mZoomFactor;
	CPUTGeometrySprite*					mpBorderSprite;
	CPUTMaterial*				mpBorderMaterial;
	CPUTMaterial*				mpZoomMaterial;
	CPUTBufferDX11*			    mpZoomBoxConstants;
    ID3D11Texture2D*            m_pZoomT;
    ID3D11ShaderResourceView*   m_pZoomSRV;
	CPUTTextureDX11*            mZoomTxT;

    int                         mScreenWidth;
    int                         mScreenHeight;

public:
    CPUTZoomBox();
    virtual ~CPUTZoomBox();

    void SetZoomCenterPosition(float x, float y);

    HRESULT OnCreate(ID3D11Device* pD3DDevice, ID3D11DeviceContext* pContext, IDXGISwapChain* pSwapChain);
    void    OnShutdown();
	void	OnFrameRender(CPUTRenderParametersDX &renderParams , cString cEffectName, bool showEdgeInfo );
    HRESULT OnSize(ID3D11Device* pD3DDevice, int width, int height);

    float2  GetCenterPos( )     { return mvZoomCenterPos; }

    ID3D11Texture2D * GetZoomColourTxtNoAddRef()    { return m_pZoomT; }

private:

};